#include <windows.h>
#include <stdio.h>
#include <time.h>
#include "tempra.h"

#define WM_NOTIFYICON (WM_USER + 100)

int GetBackupFolder(char *,char *,int);
int lastYen(unsigned char *);
int TempraSave( int, char *, char * );
int TempraRestore( int, char *, char * );
int indicator(char *);

HINSTANCE hInst;
HWND hWnd;
int winVersion,nBackupTime,tasktray;
int scrsvr=0;	/*ذݾްOFF*/
char dos_device[3],backupdir[256],ini_name[256];
SC_HANDLE	hScManager;				// Service Control Manager
SC_HANDLE	hService;				// Service (= Driver)

	char buffer[400];

void CALLBACK TimerProc(HWND hwnd,UINT umsg,UINT id,DWORD dwtime)
{
	SERVICE_STATUS	stat;
	int ret;

	// hCoJnĂȂΏI
	ret=0;
	if(hService){
		if(QueryServiceStatus(hService, &stat)){
			if(stat.dwCurrentState==SERVICE_RUNNING) ret=1;
		}
	}
	if(ret==0){
#if DBG
		indicator("hCo~܂");
#endif
		DestroyWindow(hwnd);
		return;
	}

	if(nBackupTime==2){
		SystemParametersInfo(/*SPI_GETSCREENSAVEACTIVE*/114, 0, &ret, 0);
		if(scrsvr==0 && ret!=0){
			strcpy(buffer,"2000/");
			_strdate(buffer+strlen(buffer));
			buffer[2]=buffer[11];
			buffer[3]=buffer[12];
			buffer[10]=' ';
			buffer[11]='\0';
			_strtime(buffer+strlen(buffer));
			TempraSave(0,dos_device,backupdir);
			strcat(buffer,"-");
			_strtime(buffer+strlen(buffer));
			WritePrivateProfileString("BACKUP","SCREENSAVE",buffer,ini_name);
		}
		scrsvr=ret;
	}
	return;
}

LRESULT CALLBACK MainWndProc(
	HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{
static NOTIFYICONDATA nid;

	switch (message) {
	case WM_CREATE:
	{
		OSVERSIONINFO osver;
		SERVICE_STATUS	stat;
		int ret;

		hScManager = OpenSCManager(
			NULL,							// local machine
			NULL,							// local database
			SC_MANAGER_CONNECT);			// access required
		if(hScManager){
			hService = OpenService(
				hScManager,					// Service control manager
				APPNAME,					// service name
				SERVICE_QUERY_STATUS);		// service access mode
		}

		// hCoJnĂȂΏI
		ret=0;
		if(hService){
			if(QueryServiceStatus(hService, &stat)){
				if(stat.dwCurrentState==SERVICE_RUNNING) ret=1;
			}
		}
		if(ret==0){
#if DBG
			indicator("hCoJnĂ܂");
#endif
			DestroyWindow(hwnd);
			break;
		}

		// backup folder
		backupdir[0]='\0';
		GetBackupFolder(ini_name,backupdir,sizeof(backupdir));

		// backup time
		GetPrivateProfileString(APPNAME,"%backuptime%","",buffer,sizeof(buffer),ini_name);
		nBackupTime=0;
		if(stricmp(buffer,"suspend")==0) nBackupTime=1;
		if(stricmp(buffer,"SCR")==0)     nBackupTime=2;

		if(TempraRestore(1,dos_device,backupdir)!=0){
			if(backupdir[0]!='\0'){
				backupdir[0]='\0';
				MessageBox(hwnd,
					"RAM-DISKւ̕Ɏs߃obNAbv@\𖳌ɂ܂B",
					WINDOWNAME,MB_OK | MB_SYSTEMMODAL);
				DestroyWindow(hwnd);
				break;
			}
		}


		// nro[W擾
		osver.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&osver);
		winVersion=osver.dwMajorVersion;

		tasktray=GetPrivateProfileInt(APPNAME,"%tasktray%",1,ini_name);
		if(tasktray){
			nid.cbSize = sizeof(NOTIFYICONDATA);
			nid.uID = /*ID_TASK*/0;
			nid.hWnd = hwnd;
			nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			nid.hIcon = LoadIcon( hInst,APPNAME );
			nid.uCallbackMessage = WM_NOTIFYICON;
			strcpy( nid.szTip, APPNAME );
			Shell_NotifyIcon( NIM_ADD, &nid );
		}

		SetProcessShutdownParameters(0x4ff,0);	// shutdown̗D揇ʂōɐݒ
		SetTimer(hwnd,2,3000,TimerProc);
		break;
	}

	case WM_CLOSE:
#if DBG
		indicator("TEMPRAbak.exeIĂ܂");
#endif
		TempraSave(1,dos_device,backupdir);
		DestroyWindow(hwnd);
		break;

	case WM_POWERBROADCAST:
	/*
	WM_POWERBROADCASTwParamȉ̒l̂̂AXPłSAVłR 
		PBT_APMQUERYSUSPEND(0x0) --- XP̂
		PBT_APMSUSPEND(0x4)
		PBT_APMRESUMESUSPEND(0x7)
		PBT_APMRESUMEAUTOMATIC(0x12)
	*/
		if(nBackupTime==1 && wParam==PBT_APMSUSPEND){
			strcpy(buffer,"2000/");
			_strdate(buffer+strlen(buffer));
			buffer[2]=buffer[11];
			buffer[3]=buffer[12];
			buffer[10]=' ';
			buffer[11]='\0';
			_strtime(buffer+strlen(buffer));
			TempraSave(1,dos_device,backupdir);
			strcat(buffer,"-");
			_strtime(buffer+strlen(buffer));
			WritePrivateProfileString("BACKUP","POWERBROADCAST",buffer,ini_name);
		}
		break;

	case WM_QUERYENDSESSION:
//		MessageBox(hwnd,"busy","",MB_OK);
		if(winVersion>5){
			ShowWindow(hwnd,SW_HIDE);
#if DBG
			indicator("QUERYENDSESSION(Win7)");
#endif
			return FALSE;	// Windows7
		}
		return TRUE;					// WindowsXP

	case WM_ENDSESSION:
	{
		HMODULE hMod;
		FARPROC lpfn_SBR_Create,lpfn_SBR_Destroy;

		if(winVersion>5){	// Windows7
			hMod=LoadLibrary("user32.dll");
			if(hMod){
				lpfn_SBR_Create=GetProcAddress(hMod,"ShutdownBlockReasonCreate");
				lpfn_SBR_Destroy=GetProcAddress(hMod,"ShutdownBlockReasonDestroy");
				if(!lpfn_SBR_Create || !lpfn_SBR_Destroy ){
					MessageBox(hwnd,"ShutdownBlockReason function","error",MB_OK);
				}
			}
			else{
				MessageBox(hwnd,"LoadLibrary(\"shell32.dll\")","error",MB_OK);
			}
			lpfn_SBR_Create(hwnd,L"΂炭҂");
		}

		strcpy(buffer,"2000/");
		_strdate(buffer+strlen(buffer));
		buffer[2]=buffer[11];
		buffer[3]=buffer[12];
		buffer[10]=' ';
		buffer[11]='\0';
		_strtime(buffer+strlen(buffer));
#if DBG
		if(lParam & ENDSESSION_LOGOFF) indicator("Logoff"); else indicator("Shutdown");
#endif

		TempraSave(1,dos_device,backupdir);
		if(winVersion>5){	// Windows7
			lpfn_SBR_Destroy(hwnd);
			FreeLibrary(hMod);
		}

		strcat(buffer,"-");
		_strtime(buffer+strlen(buffer));
		WritePrivateProfileString("BACKUP","ENDSESSION",buffer,ini_name);
#if DBG
		if(lParam & ENDSESSION_LOGOFF) indicator("Done(Logoff)"); else indicator("Done(Shutdown)");
#endif
        break;
	}

	case WM_NOTIFYICON:
	{
		POINT point;
		HMENU hMenu,hMenuTrackPopup;
		int ret;

		if(lParam==WM_RBUTTONDOWN){
			SetForegroundWindow(hwnd);	// ̏YꂸɁI
			GetCursorPos(&point);
			hMenu = LoadMenu (hInst, "PopupMenu");
			if (!hMenu) break;
			hMenuTrackPopup = GetSubMenu (hMenu, 0);
			ret=TrackPopupMenu (hMenuTrackPopup,
				TPM_RIGHTALIGN | TPM_BOTTOMALIGN | TPM_RETURNCMD,
				point.x, point.y, 0, hwnd, NULL);
			DestroyMenu (hMenu);
			if(ret==NI_VER)
			{
				char *pbuf,work[16],filesystem[16];
				DWORD n1,n2,sec_Clus,bySec;
				_int64 totalsize,freesize,nn64;

				sprintf(work,"%s\\",dos_device);
				GetVolumeInformation(work,NULL,0,NULL,
					&n1,&n2,filesystem,sizeof(filesystem));
				GetDiskFreeSpace(work,&sec_Clus,&bySec,&n1,&n2);
				n1=sec_Clus*bySec;
				GetDiskFreeSpaceEx(work,(ULARGE_INTEGER *)&freesize,
					(ULARGE_INTEGER *)&totalsize,(ULARGE_INTEGER *)&nn64);

				sprintf(buffer,"%I64d",totalsize);
				n2=strlen(buffer) % 3;
				work[0]='\0';
				pbuf=buffer;
				if(n2>0){
					strncat(work,buffer,n2);
					strcat(work,",");
					pbuf+=n2;
				}
				while(*pbuf){
					strncat(work,pbuf,3);
					strcat(work,",");
					pbuf+=3;
				}

				sprintf(buffer,
					"e|[fBXN <TEMPRA.EXE>\n"
					"hCu %c ɑgݍ݂܂\n\n"
					"  ̧ټ   %s\n"
					"  ި   %s޲\n"
					"  ׽    %d޲\n\n"
					"  ޯ̫ :\n    %s ",
					dos_device[0],filesystem,work,n1,backupdir);
				MessageBox(hwnd,buffer,WINDOWNAME,MB_OK | MB_SYSTEMMODAL);
			}
		}
		PostMessage(hwnd,0,0,0);	// ̏YꂸɁI
		break;
	}

	case WM_DESTROY:
		KillTimer(hwnd,2);
		if(tasktray) Shell_NotifyIcon( NIM_DELETE, &nid );	// ̏YꂸɁI
		if(hService) CloseServiceHandle(hService);
		if(hScManager) CloseServiceHandle(hScManager);
		PostQuitMessage(0);
		break;

	default:
		return (DefWindowProc(hwnd, message, wParam, lParam));
	}

   return 0L;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
MSG msg;
WNDCLASS wc;

	hInst = hInstance;

// ʃvZXTEMPRAbaks`FbN
	if((hWnd=FindWindow(APPNAME "bak",WINDOWNAME))!=NULL){
		if(lpCmdLine[0]=='\0'){
			MessageBox(NULL,"ʃvZXTEMPRAbaks",
				WINDOWNAME,MB_OK |MB_ICONSTOP | MB_SYSTEMMODAL);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
	}

// TEMPRAbak.exe̋NpX擾ďt@C쐬
	GetModuleFileName(hInst,buffer,sizeof(buffer));
	*(buffer+strlen(buffer)-strlen(APPNAME "bak.exe"))='\0';
	SetCurrentDirectory(buffer);
	strcpy(ini_name,buffer);
	strcat(ini_name,APPNAME);
	strcat(ini_name,".ini");

	strcpy(dos_device,lpCmdLine);

// EBhEf[^̏ƃEBhENX̓o^
   if (!hPrevInstance) {
      wc.style = 0;
      wc.lpfnWndProc = MainWndProc;
      wc.cbClsExtra = 0;
      wc.cbWndExtra = 0;
      wc.hInstance = hInst;
      wc.hIcon = LoadIcon(hInst, "Tempra");
      wc.hCursor = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = GetStockObject(WHITE_BRUSH);
      wc.lpszMenuName = NULL;
      wc.lpszClassName = APPNAME "bak";
      if (RegisterClass(&wc) == 0) return -1;
   }

// CEBhE쐬
	hWnd = CreateWindow(
		APPNAME "bak",
		WINDOWNAME,
		WS_OVERLAPPEDWINDOW,
		100,50,370,200,
		NULL,
		NULL,
		hInst,
		NULL
	);
	if (!hWnd) return -1;

	ShowWindow(hWnd, SW_HIDE);

/* --------------------------------------------------------------- */
/* AvP[Vւ̃bZ[W̎擾ƁȀB              */
/* --------------------------------------------------------------- */
	while (GetMessage(&msg, 0, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}
