#include <windows.h>
#include <stdio.h>
#include "tempra.h"


int errmsg(char *msg)
{
int errNo;
char buf[256],caption[40];

	if(strlen(msg)>1){
		strcpy(buf,msg);
		strcpy(caption,"G[");
	}
	else{
		errNo=GetLastError();
		FormatMessage(
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS |
			FORMAT_MESSAGE_MAX_WIDTH_MASK,
			NULL,
			errNo,
			0/*MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)*/, // ,
			buf,sizeof(buf),NULL);
		if(*msg!='\0'){
			// debugpɃG[ӏcaptionɕ\
			sprintf(caption,"G[ (No.=%04d-%s)",errNo,msg);
		}
		else{
			sprintf(caption,"G[ (No.=%04d)",errNo);
		}
	}
	MessageBox(NULL,buf,caption,MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
	return errNo;
}

int lastYen(unsigned char *str)
{
// ustrv̍Ṓu\v{
// ߂l͐擪u\v̎ 0A݂Ȃꍇ -1
	int ii,yen;

	yen= -1;
	ii = 0;
	while(str[ii]){
		/*  1oCg : 0x81 <= c <= 0x9F or 0xE0 <= c <= 0xFC */
		/*  2oCg : 0x40 <= c <= 0x7E or 0x80 <= c <= 0xFC */
		if( ((str[ii]  >=0x81 && str[ii]  <=0x9f) || (str[ii]  >=0xe0 && str[ii]  <=0xfc)) &&
			((str[ii+1]>=0x40 && str[ii+1]<=0x7e) || (str[ii+1]>=0x80 && str[ii+1]<=0xfc)) ){
			ii+=2;
		}
		else{
			if(str[ii]=='\\') yen=ii;
			ii++;
		}
	}
	return yen;
}

int GetBackupFolder(char *ininame,char *backupfolder,int size)
/*
backupfolder̃tpX߂B
backupfolderNULLœ͂ꂽ̏ꍇ́At@C
u%BackupDir%ṽtpX߂

Ԃl  1:nj
	    0:w肳ĂȂ
	   -1:sigAeڸؓ̒nA
				ٰިڸ؋yȯܰײނ̓_j
*/
{
int attr;
char buf[MAX_PATH];

	if(backupfolder[0]=='\0'){
		GetPrivateProfileString(APPNAME,"%BackupDir%","",backupfolder,size,ininame);
		if(backupfolder[0]=='\0') return 0;
	}

	if(strncmp(backupfolder,"\\\\",2)==0){
		goto _nogood;
	}
	else{
		if(strncmp(backupfolder,".\\",2)==0 || strncmp(backupfolder,"..\\",3)==0){
			GetCurrentDirectory(sizeof(buf),buf);
			if(!SetCurrentDirectory(backupfolder)) goto _nogood;
			GetCurrentDirectory(size,backupfolder);
			SetCurrentDirectory(buf);
		}
		else{
			attr=GetFileAttributes(backupfolder);
			if(attr==-1 || (attr & FILE_ATTRIBUTE_DIRECTORY)==0) goto _nogood;
		}

		backupfolder[0]=toupper(backupfolder[0]);
		if(backupfolder[0]<'C' || backupfolder[0]>'Z' || backupfolder[1]!=':') goto _nogood;
		if(lastYen(backupfolder)!=(int)strlen(backupfolder)-1) strcat(backupfolder,"\\");
		if(strcmp(backupfolder+2,"\\")==0) goto _nogood;

		buf[0]='\0';
		strncat(buf,ininame,strlen(ininame)-strlen(APPNAME)-4);
		if(strnicmp(buf,backupfolder,strlen(backupfolder))==0) goto _nogood;
	}
	return 1;

_nogood:;
	backupfolder[0]='\0';
	return -1;
}
