# Nmake macros for building Windows 32-Bit apps

##### for DEBUG #####
#DEBUG = -Z7 -Od
#LDEBUG = /DEBUG /DEBUGTYPE:cv

##########################################################################
NAME = TEMPRAini
EXE = $(NAME).exe
RES = $(NAME).res
OBJ = $(NAME).obj \
	TEMPRAetc.obj
##########################################################################

!include <win32.mak>

all: $(EXE)


##############################################################
# Update the resource if necessary
##############################################################

$(RES): $(NAME).rc tempra.h
	$(rc) $(rcflags) $(rcvars) $(NAME).rc

##############################################################
# Update the object file if necessary
##############################################################

$(OBJ): tempra.h
    $(cc) $(cflags) $(cvars) $(DEBUG) $*.c


##############################################################
# Update the executable file if necessary, and if so, add the resource back in.
##############################################################

$(EXE): $(OBJ) $(RES)
    $(link) $(LDEBUG) $(guiflags) \
	-out:$(EXE) $(OBJ) $(RES) $(guilibs) Shell32.lib Ole32.lib

