#include <windows.h>
#include <winioctl.h>
#include <stdio.h>
#include "tempra.h"

extern char svc_name[],dos_device[],inf_name[];
extern char dev_name[];
extern ULONG alloc_size;
extern char buffer[BUFFERSIZE];
extern int iBuffer;
int errmsg(char *);
int define_dos_device(int);


int DeviceOpen()
{
HANDLE hDevice;
DWORD  ret;
char extname[]={0x2e,0x56,0x46,0x44,0x00};

	if(stricmp(svc_name,"ERAM")==0) return 0;

	hDevice = CreateFile(
		dev_name,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_FLAG_NO_BUFFERING,
		NULL);
	if (hDevice == INVALID_HANDLE_VALUE){
		errmsg("4");
		return 2;
	}

	if(stricmp(svc_name,APPNAME)==0){
		ret=DeviceIoControl(
			hDevice,
			IOCTL_DEVICE_OPEN,
			NULL,
			0,
			&alloc_size,
			sizeof(ULONG),
			&iBuffer,
			NULL);
		if(!ret) errmsg("5");

		if(alloc_size==0){
			MessageBox(NULL,
				"mۂɎs܂B\nfBXNTCYĂB"
				,WINDOWNAME,MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
			return 2;
		}
	}

	if(stricmp(svc_name,extname+1)==0){
		HANDLE hFile;
		DWORD  result;
		char *image;
		struct /*IMAGE_INFO*/ {
			CHAR	DiskType;
			CHAR	MediaType;
			CHAR	MediaFlags;
			CHAR	FileType;
			ULONG	ImageSize;
			USHORT	NameLength;
			CHAR	FileName[256];
		} image_info;

		strcpy(image_info.FileName,inf_name);
		if(stricmp(image_info.FileName+strlen(image_info.FileName)-4,
			extname)!=0) strcat(image_info.FileName,extname);
		if((int)GetFileAttributes(image_info.FileName+4)== -1){	// ݂Ȃ
			hFile=CreateFile(image_info.FileName+4,
				GENERIC_WRITE,0,NULL,CREATE_NEW,
				FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH,NULL);
			image = (char *)LocalAlloc(LPTR,1474560);
			WriteFile(hFile,image,1474560,&result,NULL);
			LocalFree(image);
			CloseHandle(hFile);
		}

		image_info.NameLength	= (USHORT)strlen(image_info.FileName);

		image_info.DiskType   = (CHAR)0;
		image_info.MediaType  = (CHAR)12;
		image_info.MediaFlags = (CHAR)0;	// 1:write protect
		image_info.FileType   = (CHAR)1;
		image_info.ImageSize  = 1474560;

		ret=DeviceIoControl(	/* FOȊOAsFO*/
			hDevice,
			IOCTL_DEVICE_OPEN,
			&image_info,
			sizeof(image_info),
			NULL,
			0,
			&result,
			NULL);
	}

	if (hDevice != INVALID_HANDLE_VALUE) CloseHandle(hDevice);

	return 0;
}

int DeviceClose()
/*
߂l
   0 :
   1 :siANZXj
  -1 :Volume݂͑Ȃ
*/
{
	int ii,ret;
	HANDLE hDevice;
	char extname[]={0x56,0x46,0x44,0x00};

	hDevice = CreateFile(
		dev_name,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_FLAG_NO_BUFFERING,
		NULL);
	if (hDevice == INVALID_HANDLE_VALUE){
		errmsg("a");
		return -1;
	}

	ii=0;
	while(ii</*10*/6){
		ii++;
		ret=DeviceIoControl(hDevice,FSCTL_LOCK_VOLUME,
				NULL,0,NULL,0,&iBuffer,NULL);
		if(ret) break;
		Sleep(500);
	}

	if(!ret){
		errmsg("b");
		CloseHandle(hDevice);
		return 1;
	}
#if DBG
	else{
		if(ii>1){
			sprintf(buffer,"s %d",ii);
			MessageBox(NULL,buffer,"FSCTL_LOCK_VOLUME(DriverUnload)",MB_OK);
		}
	}
#endif


//	RAM-DISKA}Eg
	ret=ERROR_SUCCESS;

	if(stricmp(svc_name,extname)==0){
		if(!DeviceIoControl(hDevice,IOCTL_DEVICE_CLOSE,
			NULL,0,NULL,0,&iBuffer,NULL)) ret=errmsg("c");
	}

	if(ret==ERROR_SUCCESS){
		if(!DeviceIoControl(hDevice,FSCTL_DISMOUNT_VOLUME,
			NULL,0,NULL,0,&iBuffer,NULL)) ret=errmsg("d");
	}

	if(ret==ERROR_SUCCESS){
		if(!DeviceIoControl(hDevice,FSCTL_UNLOCK_VOLUME,
			NULL,0,NULL,0,&iBuffer,NULL)) ret=errmsg("e");
	}

	CloseHandle(hDevice);

	return 0;
}

int DeviceLock()
/*
߂l
  -1 :Volume݂͑Ȃ
   0 :VolumebNɐ
   1 :VolumebNɎsiANZXj
*/
{
SC_HANDLE	hScManager;				// Service Control Manager
SC_HANDLE	hService;				// Service (= Driver)
HANDLE hDevice;
int ii,ret;

	hDevice = CreateFile(
		dev_name,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_FLAG_NO_BUFFERING,
		NULL);
	if (hDevice == INVALID_HANDLE_VALUE) {
		// demandĎTEMPRAshutdownײނ
		// ~ĂB̂CreateFile()sꍇ
		// DeleteService()sTEMPRAײނ폜
		hScManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		hService = OpenService(
			hScManager,						// Service control manager
			svc_name,						// service name
			DELETE | SERVICE_STOP			// service access mode
			);
		if(DeleteService(hService)==0) errmsg("");
		if(hService) CloseServiceHandle(hService);
		if(hScManager) CloseServiceHandle(hScManager);
		return -1;
	}

	// Windows7ł́u۰ׁvJĂ邾űہHĂ܂̂
	// define_dos_deviceŴ۰ׂײނ폜
	define_dos_device(tolower(dos_device[0]));

	ii=0;
	while(ii</*10*/6){
		ii++;
		ret=DeviceIoControl(hDevice,FSCTL_LOCK_VOLUME,
				NULL,0,NULL,0,&iBuffer,NULL);
		if(ret) break;
		Sleep(500);
	}

	if(!ret){
		CloseHandle(hDevice);
		// LOCK_VOLUMEɎshCuĕ\
		define_dos_device(toupper(dos_device[0]));
		errmsg("ANZXۂ܂BhCu\n"
				"ʂ̃vZXgp̉\܂B");
		return 1;		/*ANZX*/
	}
#if DBG
	else{
		if(ii>1){
			sprintf(buffer,"s %d",ii);
			MessageBox(NULL,buffer,"FSCTL_LOCK_VOLUME(DeviceLock)",MB_OK);
		}
	}
#endif

	DeviceIoControl(hDevice,FSCTL_UNLOCK_VOLUME,NULL,0,NULL,0,&iBuffer,NULL);
	CloseHandle(hDevice);

	return 0;
}
