#include <windows.h>
#include <tchar.h>
#include <setupapi.h>
#include <stdio.h>
#include "tempra.h"

#if _MSC_VER>=1600
#include <cfgmgr32.h>
#else
#define MAX_DEVICE_ID_LEN     200
#define CR_SUCCESS                  (0x00000000)
#endif


DWORD cmpUsedDrive(DWORD);
int define_dos_device(int);
int reg_set_value(TCHAR *,TCHAR *);

#ifdef CREATEEXE
TCHAR svc_name[32],ini_name[256];
TCHAR buffer[BUFFERSIZE];
int iBuffer;
#else
extern TCHAR svc_name[32],ini_name[256];
extern TCHAR buffer[BUFFERSIZE];
extern int iBuffer;
#endif

LPSTR toSJIS(TCHAR *src)
{
static char dst[512];
#ifdef UNICODE
	int ret=WideCharToMultiByte(CP_THREAD_ACP,0,src,wcslen(src)+1,
			(LPSTR)dst,sizeof(dst),NULL,NULL);
#else
	strcpy(dst,src);
#endif
	return dst;
}

int EnumDevAll(int list,TCHAR *targetHwId)
{
	FILE *fp;

	HDEVINFO devs;
	SP_DEVINFO_DATA devInfo;
    DWORD dataType;
	int ii,nn,ret;
    DWORD reqSize;
    TCHAR devID[MAX_DEVICE_ID_LEN];
    TCHAR hwID[1000];

#if _MSC_VER<1600
	HMODULE hMod;
	FARPROC lpfnCM_Get_Device_ID_Ex;

	hMod=LoadLibrary(_T("setupapi.dll"));
#ifdef UNICODE
	lpfnCM_Get_Device_ID_Ex=GetProcAddress(hMod,"CM_Get_Device_ID_ExW");
#else
	lpfnCM_Get_Device_ID_Ex=GetProcAddress(hMod,"CM_Get_Device_ID_ExA");
#endif
#endif


	devs = SetupDiGetClassDevs(
		/*I*/ NULL,
		/*I*/ NULL,
		/*I*/ NULL,
		/*I*/ DIGCF_ALLCLASSES | DIGCF_PRESENT
		);

	if(list){
		fp=_tfopen(_T("DeviceList.txt"),_T("w"));
		_tcscpy(buffer,_T("f޲Xꗗ\"));
		_tcscat(buffer,_T(" ("));
		_tcscat(buffer,WINDOWNAME);
		_tcscat(buffer,_T(")"));
		// ̧ޯāAAALApŁASpJio
		fprintf(fp,"%s\n\n",toSJIS(buffer));
	}

	devInfo.cbSize = sizeof(devInfo);
	nn=0;
	for(ii=0;SetupDiEnumDeviceInfo(devs,ii,&devInfo);ii++){

#if _MSC_VER<1600
        ret=lpfnCM_Get_Device_ID_Ex
#else
        ret=CM_Get_Device_ID_Ex
#endif
			(
			/*I*/ devInfo.DevInst,
			/*O*/ devID,
			/*I*/ MAX_DEVICE_ID_LEN,
			/*I*/ 0,
			/*I*/ NULL);
		if(ret!=CR_SUCCESS){
            devID[0] = _T('\0');
        }

		ret=SetupDiGetDeviceRegistryProperty(
			devs,&devInfo,SPDRP_HARDWAREID,&dataType,
			(LPBYTE)hwID,sizeof(hwID)/sizeof(TCHAR),&reqSize);
		if(!ret || dataType!=REG_MULTI_SZ) _tcscpy(hwID,_T(""));
		if(sizeof(hwID)<reqSize) _tcscpy(hwID,_T("*** error : hwID̃TCYs ***"));
        if(_tcsicmp(hwID,targetHwId)==0) nn++;

		ret=SetupDiGetDeviceRegistryProperty(
			devs,&devInfo,SPDRP_SERVICE,&dataType,
			(LPBYTE)buffer,sizeof(buffer)/sizeof(TCHAR),&iBuffer);
		if(!ret || dataType!=REG_SZ) _tcscpy(buffer,_T(""));

		if(list){
			fprintf(fp,"%3d devID=w%sx\n",ii,toSJIS(devID));
			fprintf(fp,"    hwID =w%sx(reqSize=%d)\n",toSJIS(hwID),reqSize);
			fprintf(fp,"    service=w%sx\n",toSJIS(buffer));
		}

		ret=SetupDiGetDeviceRegistryProperty(
			devs,&devInfo,SPDRP_DEVICEDESC,&dataType,
			(LPBYTE)buffer,sizeof(buffer)/sizeof(TCHAR),&iBuffer);
		if(!ret || dataType!=REG_SZ) _tcscpy(buffer,_T(""));
		if(list){
			fprintf(fp,"    DEVICEDESC=w%sx\n\n",toSJIS(buffer));
		}
	}

    if(devs != INVALID_HANDLE_VALUE) {
        SetupDiDestroyDeviceInfoList(devs);
    }

	if(list){
		wsprintf(buffer,
			_T("ʰ޳IDw%sx̃foCXF%3d\n")
			,targetHwId,nn);
		fprintf(fp,"%s",toSJIS(buffer));
		fclose(fp);
	}

	return nn;
}

int setupDriver(TCHAR *inf_name,TCHAR *targetHwId)
{
	HMODULE hMod;
	FARPROC lpFunc;
	int ret,reboot;

	GUID ClassGuid;
	TCHAR ClassName[32];
    DWORD reqSize;

    HDEVINFO devs = INVALID_HANDLE_VALUE;
    SP_DEVINFO_DATA devInfo;


#ifdef CREATEEXE
	iBuffer=1;
#else
	iBuffer=0;
#endif
	if(EnumDevAll(iBuffer,targetHwId)>0){
		wsprintf(buffer,
			_T("ʰ޳IDu%sv͊ɑ݂܂B\n%sײް̲ݽİق͒~܂B")
			,targetHwId,svc_name);
		MessageBox(NULL,buffer,_T("G["),MB_OK | MB_ICONEXCLAMATION);
		return 0;
	}
	reg_set_value(ini_name,svc_name);

	ret=SetupDiGetINFClass(
		/*I*/ inf_name,
		/*O*/ &ClassGuid,
		/*O*/ ClassName,
		/*I*/ sizeof(ClassName),
		/*O*/ &reqSize
	);

	devs=SetupDiCreateDeviceInfoList(
		/*I*/ &ClassGuid,
		/*I*/ NULL
	);

	devInfo.cbSize=sizeof(SP_DEVINFO_DATA);
	ret=SetupDiCreateDeviceInfo(
		/*I*/ devs,
		/*I*/ ClassName,
		/*I*/ &ClassGuid,
		/*I*/ /*DeviceDescription*/NULL,
		/*I*/ NULL,
		/*I*/ /*CreationFlags*/DICD_GENERATE_ID/*(=1)*/,
		/*O*/ &devInfo
	);

	memset(buffer,'\0',sizeof(buffer));
	_tcscpy(buffer,targetHwId);
	ret=SetupDiSetDeviceRegistryProperty(
		/*I*/ devs,
		/*IO*/&devInfo,
		/*I*/ /*Property*/SPDRP_HARDWAREID,
		/*I*/ (LPBYTE)buffer,
		/*I*/ /*sizeof*/(_tcslen(buffer)+2)*sizeof(TCHAR)
	);

	ret=SetupDiCallClassInstaller(
		/*I*/ /*InstallFunction*/0x019,
		/*I*/ devs,
		/*I*/ &devInfo
	);

	ret=0;
	hMod=LoadLibrary(_T("NewDev.dll"));
	if(hMod){
#ifdef UNICODE
		lpFunc=GetProcAddress(hMod,"UpdateDriverForPlugAndPlayDevicesW");
#else
		lpFunc=GetProcAddress(hMod,"UpdateDriverForPlugAndPlayDevicesA");
#endif
		if(lpFunc){
			if(lpFunc(0,targetHwId,inf_name,1,&reboot)){
				if(reboot) ret= -1; else ret=1;
			}
		}
	}
	FreeLibrary(hMod);

    if(devs != INVALID_HANDLE_VALUE) {
        SetupDiDestroyDeviceInfoList(devs);
    }

	return ret;
}

int removeDev(HDEVINFO devs,PSP_DEVINFO_DATA pdevInfo)
{
    SP_REMOVEDEVICE_PARAMS rmdParams;
    SP_DEVINSTALL_PARAMS devParams;

#if 0	// ȂĂnj݂Ȃ̂ō폜
    TCHAR devID[MAX_DEVICE_ID_LEN];
    SP_DEVINFO_LIST_DETAIL_DATA devInfoListDetail;

    devInfoListDetail.cbSize = sizeof(devInfoListDetail);
    if((!SetupDiGetDeviceInfoListDetail(
			/*I*/ devs,
			/*O*/ &devInfoListDetail)) ||
		(CM_Get_Device_ID_Ex(
			/*I*/ pdevInfo->DevInst,
			/*O*/ devID,
			/*I*/ MAX_DEVICE_ID_LEN,
			/*I*/ 0,
			/*I*/ devInfoListDetail.RemoteMachineHandle
		) != CR_SUCCESS)
	){
        return 0;
    }
#endif

    rmdParams.ClassInstallHeader.cbSize = sizeof(SP_CLASSINSTALL_HEADER);
    rmdParams.ClassInstallHeader.InstallFunction = DIF_REMOVE;
    rmdParams.Scope = DI_REMOVEDEVICE_GLOBAL;
    rmdParams.HwProfile = 0;
    if(!SetupDiSetClassInstallParams(
			/*I*/ devs,
			/*I*/ pdevInfo,
			/*I*/ &rmdParams.ClassInstallHeader,
			/*I*/ sizeof(rmdParams)) ||
		!SetupDiCallClassInstaller(
			/*I*/ DIF_REMOVE,
			/*I*/ devs,
			/*I*/ pdevInfo))
	{
        return 0;
    }
	else {
        devParams.cbSize = sizeof(devParams);
        if(SetupDiGetDeviceInstallParams(
			devs,
			pdevInfo,&devParams))
		{
	        if(devParams.Flags & (DI_NEEDRESTART | DI_NEEDREBOOT)) {
	            return -1;
			}
        }
    }
	return 1;
}


int removeDriver(TCHAR *inf_name,TCHAR *targetHwId)
{
	int count,reboot;

	GUID ClassGuid;
	TCHAR ClassName[32];

    HDEVINFO devs = INVALID_HANDLE_VALUE;
    int ret,retcode;
    DWORD devIndex;
    SP_DEVINFO_DATA devInfo;

    TCHAR devID[MAX_DEVICE_ID_LEN];
    TCHAR hwID[1000];
    DWORD dataType;
    DWORD reqSize;

	SC_HANDLE	hScManager;				// Service Control Manager
	SC_HANDLE	hService;				// Service (= Driver)
	SERVICE_STATUS	stat;

#if _MSC_VER<1600
	HMODULE hMod;
	FARPROC lpfnCM_Get_Device_ID_Ex;

	hMod=LoadLibrary(_T("setupapi.dll"));
#ifdef UNICODE
	lpfnCM_Get_Device_ID_Ex=GetProcAddress(hMod,"CM_Get_Device_ID_ExW");
#else
	lpfnCM_Get_Device_ID_Ex=GetProcAddress(hMod,"CM_Get_Device_ID_ExA");
#endif
#endif

    count = 0;
    reboot= 0;

	if(_tcslen(inf_name)>0){
		ret=SetupDiGetINFClass(
			/*I*/ inf_name,
			/*O*/ &ClassGuid,
			/*O*/ ClassName,
			/*I*/ sizeof(ClassName),
			/*O*/ &reqSize
		);

#if _MSC_VER<1600
		devs = SetupDiGetClassDevs(
			/*I*/ &ClassGuid,
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ DIGCF_PRESENT
			);
#else
		devs = SetupDiGetClassDevsEx(
			/*I*/ &ClassGuid,
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ DIGCF_PRESENT,
			/*I*/ NULL,
			/*I*/ NULL,
			/*R*/ NULL);
#endif
	}
	else{
#if _MSC_VER<1600
		devs = SetupDiGetClassDevs(
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ DIGCF_ALLCLASSES | DIGCF_PRESENT
			);
#else
		devs = SetupDiGetClassDevsEx(
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ NULL,
			/*I*/ DIGCF_ALLCLASSES | DIGCF_PRESENT,
			/*I*/ NULL,
			/*I*/ NULL,
			/*R*/ NULL);
#endif
	}
    if(devs == INVALID_HANDLE_VALUE) {
        goto final;
    }

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#if 0	// VC++ 6.0ł̓G[ɂȂ̂ō폜iȂĂnj݂Ȃ̂Łj
{
	SP_DEVINFO_LIST_DETAIL_DATA devInfoListDetail;

	devInfoListDetail.cbSize = sizeof(devInfoListDetail);
    if(!SetupDiGetDeviceInfoListDetail(
		/*I*/ devs,
		/*O*/ &devInfoListDetail))
	{
        goto final;
    }
}
#endif
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

    devInfo.cbSize = sizeof(devInfo);
	iBuffer=0;
    devIndex=0;
    for(devIndex=0;
		SetupDiEnumDeviceInfo(
			/*I*/ devs,
			/*I*/ devIndex,
			/*O*/ &devInfo);
		devIndex++)
	{

		if(devIndex==(DWORD)iBuffer){
			iBuffer=iBuffer+0;	// debugp break point
		}

#if _MSC_VER<1600
        ret=lpfnCM_Get_Device_ID_Ex
#else
        ret=CM_Get_Device_ID_Ex
#endif
			(
			/*I*/ devInfo.DevInst,
			/*O*/ devID,
			/*I*/ MAX_DEVICE_ID_LEN,
			/*I*/ 0,
			/*I*/ NULL);
		if(ret!=CR_SUCCESS){
            devID[0] = _T('\0');
        }

	    if(SetupDiGetDeviceRegistryProperty(
			/*I*/ devs,
			/*I*/ &devInfo,
			/*I*/ SPDRP_HARDWAREID,
			/*O*/ &dataType,
			/*O*/ (LPBYTE)hwID,
			/*I*/ sizeof(hwID)/sizeof(TCHAR),
			/*O*/ &reqSize))
		{
	        if(dataType != REG_MULTI_SZ) _tcscpy(hwID,_T(""));
		}
		else{
			_tcscpy(hwID,_T(""));
		}

        if(_tcsicmp(hwID,targetHwId)==0){
//=========================================================
			wsprintf(buffer,
				_T("%s 폜܂B낵łB\n\n  foCXID : %s\n  ʰ޳ID : %s"),
				svc_name,devID,hwID);
			if(_tcslen(inf_name)==0){
				ret=MessageBox(NULL,buffer,_T("mF"),MB_YESNOCANCEL | MB_ICONQUESTION);
			}
			else{
				ret=MessageBox(NULL,buffer,_T("mF"),MB_YESNO | MB_ICONQUESTION);
			}
			if(ret==IDCANCEL) return 0;
			if(ret==IDYES){
				retcode = removeDev(devs,&devInfo);
				if(retcode){
					count++;
					if(retcode<0) reboot++;
				}
			}
//=========================================================
        }
    }


final:
    if(devs != INVALID_HANDLE_VALUE) {
        SetupDiDestroyDeviceInfoList(devs);
    }

#if _MSC_VER<1600
	FreeLibrary(hMod);
#endif

	retcode=count;
    if(reboot>0) retcode= -count;

//=========================================================
#ifdef CREATEEXE
	wsprintf(buffer,
		_T("Remove %s ( code=%d )\n\n  ʰ޳ID : %s"),
		svc_name,retcode,targetHwId);
	MessageBox(NULL,buffer,_T("SetupDi"),MB_OK);
#endif
//=========================================================

	if(ret){
		hScManager = OpenSCManager(
			NULL,							// local machine
			NULL,							// local database
			SC_MANAGER_CONNECT);			// access required
		if(hScManager){
			hService = OpenService(
				hScManager,					// Service control manager
				svc_name,						// service name
				DELETE | SERVICE_STOP		// service access mode
				);
			if(hService){
				ControlService(hService, SERVICE_CONTROL_STOP, &stat);
				DeleteService(hService);
				CloseServiceHandle(hService);
			}
			CloseServiceHandle(hScManager);
		}
	}

    return retcode;
}


#ifdef CREATEEXE
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
	int ret,drv,driveLetters;
	TCHAR hardwareID[32],inf_name[256];

	int driver_state;
	SC_HANDLE	hScManager;				// Service Control Manager
	SC_HANDLE	hService;				// Service (= Driver)
	SERVICE_STATUS	stat;

	wsprintf(buffer,_T("_MSC_VER=%d"),_MSC_VER);
#ifdef UNICODE
	_tcscat(buffer,_T(" (UNICODE)"));
#endif
	MessageBox(NULL,buffer,_T("SetupDi"),MB_OK);

	GetModuleFileName(hInstance,buffer,sizeof(buffer));
	*(buffer+_tcslen(buffer)-_tcslen(_T("setupDi.exe")))=_T('\0');
	_tcscpy(ini_name,buffer);
	_tcscat(ini_name,_T("tempra.ini"));
	GetPrivateProfileString(_T("DRIVER"),_T("name"),APPNAME,svc_name,sizeof(svc_name),ini_name);

	GetPrivateProfileString(svc_name,_T("%HWID%"),_T(""),hardwareID,sizeof(hardwareID),ini_name);
	if(hardwareID[0]==_T('\0')){
		MessageBox(NULL,
			_T("ʰ޳IDsłB"),
			_T("SetupDi"),MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(_tcsicmp(hardwareID,_T("NULL"))==0) hardwareID[0]=_T('\0');

	GetPrivateProfileString(svc_name,_T("%INF%"),_T(""),buffer,sizeof(buffer),ini_name);
	if(buffer[0]==_T('\0')){
		MessageBox(NULL,
			_T("INFt@CsłB"),
			_T("SetupDi"),MB_OK | MB_ICONSTOP);
		return 0;
	}
	if(_tcsicmp(buffer,_T("NULL"))==0){
		inf_name[0]=_T('\0');
	}
	else{
		inf_name[0]=_T('\0');
		_tcsncat(inf_name,ini_name,_tcslen(ini_name)-_tcslen(_T("TEMPRA.ini")));
		_tcscat(inf_name,buffer);
		if(GetFileAttributes(inf_name)== -1){
			MessageBox(NULL,
				_T("INFt@C܂B"),
				_T("SetupDi"),MB_OK | MB_ICONSTOP);
			return 0;
		}
	}


	driveLetters=GetLogicalDrives();

	driver_state= -1;
	hScManager = OpenSCManager(
		NULL,							// local machine
		NULL,							// local database
		SC_MANAGER_CONNECT);			// access required
	if(hScManager){
		hService = OpenService(
			hScManager,					// Service control manager
			svc_name,					// service name
			SERVICE_QUERY_STATUS);		// service access mode
		if(hService){
			if(QueryServiceStatus(hService, &stat)) driver_state=stat.dwCurrentState;
			CloseServiceHandle(hService);
		}
		CloseServiceHandle(hScManager);
	}


//------------------------------------------------------------
	_tcscpy(buffer,GetCommandLine() + _tcslen(GetCommandLine())-strlen(lpCmdLine) );
	if(_tcsicmp(buffer,_T("/remove"))!=0 && driver_state<=0){
		ret=setupDriver(inf_name,hardwareID);
		if(ret){
			drv=cmpUsedDrive(driveLetters);
			if(drv>=(int)('A')){
				define_dos_device(drv);
			}
			_tcscpy(buffer,_T("Install (Success)"));
			if(ret<0) _tcscpy(buffer,_T("Install (need Reboot)"));
		}
		else{
			_tcscpy(buffer,_T("Install (Failed)"));
		}
	}
//------------------------------------------------------------
	else{
		ret=removeDriver(inf_name,hardwareID);
		if(ret>0){
			drv=cmpUsedDrive(driveLetters);
			if(drv>=(int)('a')){
				define_dos_device(drv);
			}
			_tcscpy(buffer,_T("Remove (Success)"));
			if(ret<0) _tcscpy(buffer,_T("Remove (need Reboot)"));
		}
		else{
			_tcscpy(buffer,_T("Remove (Failed)"));
		}
	}
//------------------------------------------------------------
	MessageBox(NULL,buffer,_T("SetupDi"),MB_OK);
	return ret;
}
#endif
