#include <windows.h>
#include <Shlobj.h>		// SHBrowseForFolder()
#include "tempra.h"


int GetBackupFolder(char *,char *,int);
char buffer[MAX_PATH],ini_name[MAX_PATH];

int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
// tH_Zbg
{
	if(uMsg==BFFM_INITIALIZED){
		SendMessage(hwnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
	}
	return 0;
}

int GetOpenFolderName(HWND hDlg)
{
	char    foldername[256];
	BROWSEINFO  binfo;
	LPITEMIDLIST idlist;

	GetDlgItemText(hDlg, IDFOLDER, foldername, sizeof(foldername));
	binfo.hwndOwner=hDlg;
	binfo.pidlRoot=NULL;
	binfo.pszDisplayName=foldername;
	binfo.lpszTitle="ۑ̃tH_̎w";
	binfo.ulFlags=BIF_RETURNONLYFSDIRS; 
	binfo.lpfn=&BrowseCallbackProc;               //R[obN֐w肷
	binfo.lParam=(LPARAM)foldername;              //R[obNɓn
	binfo.iImage=(int)NULL;
	idlist=SHBrowseForFolder(&binfo);
	SHGetPathFromIDList(idlist,foldername);
	CoTaskMemFree(idlist);

	if(foldername[0]!='\0') SetDlgItemText(hDlg, IDFOLDER, foldername);
	return strlen(foldername);
}


LONG APIENTRY DlgInitBoxProc (HWND hDlg,UINT msg,UINT wParam,LONG lParam)
//   WM_INITDIALOG    :SetForcus()ŃtH[JXݒ肵FALSEAłȂȂTRUEԂ
//   WM_INITDIALOGȊO:bZ[WȂTRUEAłȂȂFALSEԂ

{
static int bBackupDir;

	unsigned int style;
	HWND hWndBKT,hWndBKT1,hWndBKT2;

    switch (msg) {
    case WM_INITDIALOG:
		// windows
		GetPrivateProfileString(APPNAME,"%windows%","",buffer,sizeof(buffer),ini_name);
		if(stricmp(buffer,"7(32)")==0){
			SendDlgItemMessage(hDlg,IDWINVER+1,BM_SETCHECK,BST_CHECKED,0L);
		}
		else if(stricmp(buffer,"7(64)")==0){
			SendDlgItemMessage(hDlg,IDWINVER+2,BM_SETCHECK,BST_CHECKED,0L);
		}
		else{
			SendDlgItemMessage(hDlg,IDWINVER,BM_SETCHECK,BST_CHECKED,0L);
		}

		// drive letter
		GetPrivateProfileString(APPNAME,"%driveletter%","",buffer,sizeof(buffer),ini_name);
	    SetDlgItemText(hDlg, IDDRIVE, buffer);

		// disk size
		GetPrivateProfileString(APPNAME,"%disksize%","",buffer,sizeof(buffer),ini_name);
	    SetDlgItemText(hDlg, IDSIZE, buffer);

		// disk type
		GetPrivateProfileString(APPNAME,"%disktype%","",buffer,sizeof(buffer),ini_name);
		if(stricmp(buffer,"HDD")!=0){
			SendDlgItemMessage(hDlg,IDTYPE,BM_SETCHECK,BST_CHECKED,0L);
		}
		else{
			SendDlgItemMessage(hDlg,IDTYPE+1,BM_SETCHECK,BST_CHECKED,0L);
		}

		// memory
/*
		y[W Ɣy[W 
		Windows  }l[Wł́AJ[l [h \tgEFA
		J[l/VXe ̊蓖ĂɎgp\ȁATCYI
		肳郁 v[ 2 ލ쐬܂BTOIɂ́A
		̃v[̓J[l/VXe q[vƍl邱Ƃł܂B
		y[W ́AANZXOɎۂɃɑ݂邱Ƃ
		ۏ؂̂ŁA悻̂Ƃ͕ƓłBy[W
		ւ̃ANZXŃy[W tH[g邱Ƃ͂܂B
		ŁAy[W v[ ̓fBXNɃy[WO邱Ƃ
		܂B̓VXe ɂĂ̘bȂ̂ŁÃv[
		́AׂẴvZXɊ蓖Ăꂽ 2GB ̃J[l [hz
		AhXԂɃ}bv܂B
*/
		GetPrivateProfileString(APPNAME,"%memory%","",buffer,sizeof(buffer),ini_name);
		if(stricmp(buffer,"paged")==0){
			SendDlgItemMessage(hDlg,IDMEMORY,BM_SETCHECK,BST_CHECKED,0L);
		}
		else{
			SendDlgItemMessage(hDlg,IDMEMORY+1,BM_SETCHECK,BST_CHECKED,0L);
		}

		// filesystem
		GetPrivateProfileString(APPNAME,"%filesystem%","256",buffer,sizeof(buffer),ini_name);
		if(atoi(buffer)>=100){	// FAT12/16
			// ݒl̓[hfBNgGgŉL̉ꂩ
			// iDISK_INFO\̂ɂ( )̒lŕۑj
			// 128(0), 192(1), 256(2), 320(3), 384(4), 448(5), 512(6), 576(7)
			SendDlgItemMessage(hDlg,IDFLSYS,BM_SETCHECK,BST_CHECKED,0L);
		}
		else{	// FAT32
			// ݒl̓NX^TCY(KBP)ŉL̉ꂩ
			// iDISK_INFO\̂ɂ( )̒lŕۑj
			// 0.5(0),  1(1),  2(2),  4(3),  8(4), 16(5), 32(6), 64(7)
			SendDlgItemMessage(hDlg,IDFLSYS+1,BM_SETCHECK,BST_CHECKED,0L);
		}

		// backup folder
		GetPrivateProfileString(APPNAME,"%backupdir%","",buffer,sizeof(buffer),ini_name);
		bBackupDir=(int)buffer[0];
	    SetDlgItemText(hDlg, IDFOLDER, buffer);
		if(buffer[0]=='\0'){
			style=WS_VISIBLE | WS_DISABLED | BS_AUTORADIOBUTTON | WS_CHILD;
			SetWindowLong(GetDlgItem(hDlg,IDBKTIME),GWL_STYLE,style);
			SetWindowLong(GetDlgItem(hDlg,IDBKTIME+1),GWL_STYLE,style);
			SetWindowLong(GetDlgItem(hDlg,IDBKTIME+2),GWL_STYLE,style);
		}

		// backup time
		GetPrivateProfileString(APPNAME,"%backuptime%","",buffer,sizeof(buffer),ini_name);
		if(stricmp(buffer,"suspend")==0){
			SendDlgItemMessage(hDlg,IDBKTIME+1,BM_SETCHECK,BST_CHECKED,0L);
		}
		else if(stricmp(buffer,"SCR")==0){
			SendDlgItemMessage(hDlg,IDBKTIME+2,BM_SETCHECK,BST_CHECKED,0L);
		}
		else{
			SendDlgItemMessage(hDlg,IDBKTIME,BM_SETCHECK,BST_CHECKED,0L);
		}

		SetTimer(hDlg,1,500,NULL);
        break;

	case WM_TIMER:
	    GetDlgItemText(hDlg, IDFOLDER, buffer, sizeof(buffer));
		if((bBackupDir==0 && buffer[0]!='\0') || (bBackupDir!=0 && buffer[0]=='\0')){
			style=WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_TABSTOP;
			if((bBackupDir=(int)buffer[0])==0){
				style |= WS_DISABLED;
			}
			hWndBKT=GetDlgItem(hDlg,IDBKTIME);
			hWndBKT1=GetDlgItem(hDlg,IDBKTIME+1);
			hWndBKT2=GetDlgItem(hDlg,IDBKTIME+2);
			SetWindowLong(hWndBKT,GWL_STYLE,style);
			SetWindowLong(hWndBKT1,GWL_STYLE,style);
			SetWindowLong(hWndBKT2,GWL_STYLE,style);

			ShowWindow(hWndBKT,SW_HIDE);
			ShowWindow(hWndBKT1,SW_HIDE);
			ShowWindow(hWndBKT2,SW_HIDE);
			ShowWindow(hWndBKT,SW_SHOW);
			ShowWindow(hWndBKT1,SW_SHOW);
			ShowWindow(hWndBKT2,SW_SHOW);
		}
		break;

    case WM_COMMAND:
	    switch (LOWORD(wParam)) {
        case IDOK:
		{
			int ret,existdir;
			char change[MAX_PATH];

			KillTimer(hDlg,1);
			ret=0;

			// windows
			GetPrivateProfileString(APPNAME,"%windows%","",buffer,sizeof(buffer),ini_name);
			if(SendDlgItemMessage(hDlg,IDWINVER,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"XP")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%windows%","XP",ini_name);
				}
			}
			if(SendDlgItemMessage(hDlg,IDWINVER+1,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"7(32)")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%windows%","7(32)",ini_name);
				}
			}
			if(SendDlgItemMessage(hDlg,IDWINVER+2,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"7(64)")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%windows%","7(64)",ini_name);
				}
			}

			// drive letter
			GetPrivateProfileString(APPNAME,"%driveletter%","",buffer,sizeof(buffer),ini_name);
		    GetDlgItemText(hDlg, IDDRIVE, change, sizeof(change));
			change[0]=toupper(change[0]);
			if(strlen(change)==1 && change[0]>='D' && change[0]<='Z'){
				if(stricmp(buffer,change)!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%driveletter%",change,ini_name);
				}
			}
			else{
				MessageBox(hDlg,"hCusłB",WINDOWNAME,MB_OK);
				break;
			}

			// disk size
			GetPrivateProfileString(APPNAME,"%disksize%","",buffer,sizeof(buffer),ini_name);
		    GetDlgItemText(hDlg, IDSIZE, change, sizeof(change));
			if(atoi(change)>0){
				if(stricmp(buffer,change)!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%disksize%",change,ini_name);
				}
			}
			else{
				MessageBox(hDlg,"fBXNTCYsłB",WINDOWNAME,MB_OK);
				break;
			}

			// filesystem
			if(SendDlgItemMessage(hDlg,IDFLSYS,BM_GETCHECK,0,0L)==BST_CHECKED){
				// FAT12/16`FbNĂꍇ
				GetPrivateProfileString(APPNAME,"%filesystem%","256",buffer,sizeof(buffer),ini_name);
				if(atoi(buffer)<100){	// t@Č݂̐ݒlFAT32Ȃ
					// FAT12/16(ٰިڸشؐ=256)ɐݒ
					ret=1;
					WritePrivateProfileString(APPNAME,"%filesystem%","256",ini_name);
				}
			}
			else{
				// FAT32`FbNĂꍇ
			    GetDlgItemText(hDlg, IDSIZE, buffer, sizeof(buffer));
				if(atoi(buffer)<33){
					// fBXNTCY32M޲Ė͕s
					MessageBox(hDlg,
						"FAT32̏ꍇAިނ33M޲Ĉȏw肵ĂB",
						WINDOWNAME,MB_OK | MB_ICONEXCLAMATION);
					SetTimer(hDlg,1,1000,NULL);
					break;
				}
				GetPrivateProfileString(APPNAME,"%filesystem%","256",buffer,sizeof(buffer),ini_name);
				if(atoi(buffer)>=100){	// t@Č݂̐ݒlFAT12/16Ȃ
					// FAT32(׽=1K޲)ɐݒ
					ret=1;
					WritePrivateProfileString(APPNAME,"%filesystem%","1",ini_name);
				}
			}

			// disk type
			GetPrivateProfileString(APPNAME,"%disktype%","",buffer,sizeof(buffer),ini_name);
			if(SendDlgItemMessage(hDlg,IDTYPE,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"HDD")==0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%disktype%","",ini_name);
				}
			}
			else{
				if(stricmp(buffer,"HDD")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%disktype%","HDD",ini_name);
				}
			}

			// memory
			GetPrivateProfileString(APPNAME,"%memory%","",buffer,sizeof(buffer),ini_name);
			if(SendDlgItemMessage(hDlg,IDMEMORY,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"paged")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%memory%","paged",ini_name);
				}
			}
			else{
				if(stricmp(buffer,"paged")==0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%memory%","",ini_name);
				}
			}

			// backup folder
		    GetDlgItemText(hDlg, IDFOLDER, change, sizeof(change));
			if(change[0]!='\0'){
				existdir=GetBackupFolder(ini_name,change,sizeof(change));
				if(existdir<=0){
					MessageBox(NULL,"ۑpXsłB",
						WINDOWNAME,MB_OK /*| MB_SYSTEMMODAL*/);
					break;
				}
			}

		    GetDlgItemText(hDlg, IDFOLDER, change, sizeof(change));
			GetPrivateProfileString(APPNAME,"%backupdir%","",buffer,sizeof(buffer),ini_name);
			if(stricmp(buffer,change)!=0){
				ret=1;
				WritePrivateProfileString(APPNAME,"%backupdir%",change,ini_name);
			}

			// backup time
			GetPrivateProfileString(APPNAME,"%backuptime%","",buffer,sizeof(buffer),ini_name);
			if(SendDlgItemMessage(hDlg,IDBKTIME,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%backuptime%","",ini_name);
				}
			}
			if(SendDlgItemMessage(hDlg,IDBKTIME+1,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"suspend")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%backuptime%","suspend",ini_name);
				}
			}
			if(SendDlgItemMessage(hDlg,IDBKTIME+2,BM_GETCHECK,0,0L)==BST_CHECKED){
				if(stricmp(buffer,"SCR")!=0){
					ret=1;
					WritePrivateProfileString(APPNAME,"%backuptime%","SCR",ini_name);
				}
			}

			EndDialog (hDlg, ret);
			break;
		}

        case IDCANCEL:
			KillTimer(hDlg,1);
			if(MessageBox(hDlg,"LZ܂B",
				WINDOWNAME,MB_YESNO | MB_ICONQUESTION)==IDYES){
				EndDialog (hDlg, -1);
			}
			else{
				SetTimer(hDlg,1,1000,NULL);
			}
			break;

        case IDFOLDER+20:
			KillTimer(hDlg,1);
			if(GetOpenFolderName(hDlg)){
				SendDlgItemMessage(hDlg,IDFOLDER,EM_SETSEL,0,-1);
//				SendDlgItemMessage(hDlg,IDFOLDER,EM_SETSEL,0,0);
				SetFocus(GetDlgItem(hDlg,IDFOLDER));
			}
			SetTimer(hDlg,1,1000,NULL);
			break;

    	default:
			return FALSE;
		}
		break;

    default:
		return FALSE;
	}
	return TRUE;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int cmdShow)
{
int ret;

	LoadIcon(hInstance,"TempraINI");

// t@C쐬
	GetModuleFileName(hInstance,buffer,sizeof(buffer));
	*(buffer+strlen(buffer)-strlen("TEMPRAini,exe"))='\0';
	SetCurrentDirectory(buffer);
	strcpy(ini_name,buffer);
	strcat(ini_name,APPNAME);
	strcat(ini_name,".ini");

	ret=DialogBox(hInstance,"DlgInitBox",NULL,(DLGPROC)DlgInitBoxProc);
	if(ret==1){
		MessageBox(NULL,
			"IvVݒ肪ύX܂B\n\n"
			"TEMPRA.exesƐVݒ肪LɂȂ܂B",
			WINDOWNAME,MB_OK);
	}
	else if(ret==0){
		MessageBox(NULL,"ύXꂽڂ͂܂B",WINDOWNAME,MB_OK);
	}
	return ret;
}
